#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// The ChartControl sample form.
	/// </summary>
	public class FormMain : Form
	{
		private System.ComponentModel.IContainer components;
		
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private Syncfusion.Windows.Forms.BorderPanel borderPanel1;
		private System.Windows.Forms.ImageList imageList1;
        private System.Windows.Forms.PropertyGrid propertyGrid1;
        private ImageList pointImageList_;
		public FormMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
            this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
            this.borderPanel1 = new Syncfusion.Windows.Forms.BorderPanel();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
            this.SuspendLayout();
            // 
            // chartControl1
            // 
            this.chartControl1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(237)), ((System.Byte)(240)), ((System.Byte)(247)));
            this.chartControl1.ColumnWidthMode = Syncfusion.Windows.Forms.Chart.ChartColumnWidthMode.DefaultWidthMode;
            this.chartControl1.Controls.Add(this.chartControl1.Legend);
            // 
            // chartControl1.Legend
            // 
            this.chartControl1.Legend.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.chartControl1.Legend.BackColor = System.Drawing.Color.White;
            this.chartControl1.Legend.Location = new System.Drawing.Point(223, 49);
            this.chartControl1.Legend.Name = "";
            this.chartControl1.Legend.Orientation = System.Windows.Forms.Orientation.Horizontal;
            this.chartControl1.Legend.Size = new System.Drawing.Size(76, 28);
            this.chartControl1.Legend.TabIndex = 3;
            this.chartControl1.LegendPosition = Syncfusion.Windows.Forms.Chart.ChartLegendPosition.Top;
            this.chartControl1.Location = new System.Drawing.Point(0, 0);
            this.chartControl1.Name = "chartControl1";
            this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
            this.chartControl1.PrimaryXAxis.SmartDateZoomDayLevelLabelFormat = "g";
            this.chartControl1.PrimaryXAxis.SmartDateZoomMonthLevelLabelFormat = "m";
            this.chartControl1.PrimaryYAxis.SmartDateZoomDayLevelLabelFormat = "g";
            this.chartControl1.PrimaryYAxis.SmartDateZoomMonthLevelLabelFormat = "m";
            this.chartControl1.Size = new System.Drawing.Size(522, 344);
            this.chartControl1.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighSpeed;
            this.chartControl1.Spacing = 10F;
            this.chartControl1.TabIndex = 1;
            this.chartControl1.Text = "Essential Chart";
            this.chartControl1.Tilt = 30F;
            // 
            // chartControl1.ToolBar
            // 
            this.chartControl1.ToolBar.Location = new System.Drawing.Point(26, 26);
            this.chartControl1.ZoomFactorX = 1;
            this.chartControl1.ZoomFactorY = 1;
            this.chartControl1.ZoomOutIncrement = 1.5;
            // 
            // borderPanel1
            // 
            this.borderPanel1.Background = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((System.Byte)(42)), ((System.Byte)(67)), ((System.Byte)(126))));
            this.borderPanel1.Control = this.chartControl1;
            this.borderPanel1.Dimensions.All = 15;
            this.borderPanel1.Dimensions.Bottom = 15;
            this.borderPanel1.Dimensions.Left = 15;
            this.borderPanel1.Dimensions.Right = 15;
            this.borderPanel1.Dimensions.Top = 15;
            this.borderPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.borderPanel1.InnerColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
            this.borderPanel1.InnerCornerRadius.All = 10;
            this.borderPanel1.InnerCornerRadius.BottomLeft = 10;
            this.borderPanel1.InnerCornerRadius.BottomRight = 10;
            this.borderPanel1.InnerCornerRadius.TopLeft = 10;
            this.borderPanel1.InnerCornerRadius.TopRight = 10;
            this.borderPanel1.InnerState = Syncfusion.Windows.Forms.BorderPanelState.Level;
            this.borderPanel1.Location = new System.Drawing.Point(0, 0);
            this.borderPanel1.Name = "borderPanel1";
            this.borderPanel1.Size = new System.Drawing.Size(864, 373);
            this.borderPanel1.TabIndex = 0;
            // 
            // imageList1
            // 
            this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
            this.imageList1.ImageSize = new System.Drawing.Size(32, 32);
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.White;
            // 
            // propertyGrid1
            // 
            this.propertyGrid1.CommandsVisibleIfAvailable = true;
            this.propertyGrid1.LargeButtons = false;
            this.propertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.propertyGrid1.Location = new System.Drawing.Point(568, 24);
            this.propertyGrid1.Name = "propertyGrid1";
            this.propertyGrid1.Size = new System.Drawing.Size(272, 328);
            this.propertyGrid1.TabIndex = 1;
            this.propertyGrid1.Text = "propertyGrid1";
            this.propertyGrid1.ViewBackColor = System.Drawing.SystemColors.Window;
            this.propertyGrid1.ViewForeColor = System.Drawing.SystemColors.WindowText;
            this.propertyGrid1.Visible = false;
            // 
            // FormMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(864, 373);
            this.Controls.Add(this.propertyGrid1);
            this.Controls.Add(this.borderPanel1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "FormMain";
            this.Text = "Essential Chart - Chart Image List Sample";
            this.Load += new System.EventHandler(this.FormMain_Load);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		
		private void FormMain_Load(object sender, System.EventArgs e)
		{
            propertyGrid1.SelectedObject = chartControl1;
			// Specify a ChartPalette
			this.chartControl1.Model.ColorModel.Palette = ChartColorPalette.Triad;
            pointImageList_ = new ImageList();
			InitializeChartData();
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			ChartSeries series = this.chartControl1.Model.NewSeries("SymbolSeries");
			series.Text = "Image List and Image Indexes";

			this.chartControl1.LegendPosition = ChartLegendPosition.Top;
			series.SeriesIndexedModelImpl = new StringIndexedModel(series, new string[]{"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}, new double[]{68,65,72,71,73,70,68,72,67,65,64,64});
			series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);

			this.chartControl1.Indexed = true;
			this.chartControl1.PrimaryYAxis.Range.Min = 0;
			this.chartControl1.PrimaryYAxis.Range.Max = 100;
			this.chartControl1.PrimaryYAxis.Range.Interval = 10;
			this.chartControl1.PrimaryYAxis.RangeType = ChartAxisRangeType.Set;

			series.Type = ChartSeriesType.Line;
			series.Style.Symbol.Shape = ChartSymbolShape.Triangle;
			series.Style.Symbol.Size = new Size(10,10);
			series.Style.Symbol.Color = Color.Yellow;
			series.Style.DisplayShadow = true;
			series.Style.DisplayText = true;
			series.Style.PointWidth = 2;

			series.Style.Border.Color = Color.FromArgb(100, Color.Red);
			series.Style.Border.DashStyle = DashStyle.DashDotDot;

			series.Style.ImageList = this.imageList1;
			this.chartControl1.PrimaryXAxis.DrawGrid = false;
			this.chartControl1.PrimaryYAxis.DrawGrid = false;
			this.chartControl1.Series.Add(series);
            pointImageList_ = new ImageList();

		}


		/// <summary>
		/// Handler for the PrepareStyle event of ChartSeries. 
		/// </summary>
		/// <param name="sender">The ChartSeries object that raises this event.</param>
		/// <param name="args">The event data. Can be modified to change series appearance.</param>
		protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
            for(int i = 1; i < 9; i++)
            {
                string imgPath =  @"PointImages\" + i.ToString() + ".gif";
                Image image = Image.FromFile(imgPath);
                pointImageList_.Images.Add(image);
            }
            args.Style.ImageList = pointImageList_;
			Random rand = new Random();
			if(series != null)
			{
				args.Style.Text = string.Format("{0}", series.Points[args.Index].YValues[0]);
				args.Style.DisplayText = false;
				args.Style.TextOrientation = ChartTextOrientation.Center;
				args.Style.Symbol.ImageIndex = args.Index;//rand.Next(6)+1;
				args.Style.TextColor = Color.White;
				args.Style.TextOrientation = ChartTextOrientation.Up;	
				args.Style.Symbol.Shape = ChartSymbolShape.Image;
				args.Style.Symbol.Size = new Size(10,10);
                //args.Style.
			}
		}
        

		
	}
}
