#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Diagnostics;
using System.ComponentModel;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// Summary description for SimpleModel.
	/// </summary>
	public class StringIndexedModel : IChartSeriesIndexedModel
	{
		private string[] x;
		private double[] y;
		private ChartSeries series;

		public StringIndexedModel(ChartSeries series, string[] x, double[] y)
		{
			this.series = series;
			this.series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartPrepareStyleHandler);
			this.x = x;
			this.y = y;
			Trace.Assert(this.x.GetLength(0) == this.y.GetLength(0));
		}

		public int Count 
		{ 
			get
			{
				return this.x.GetLength(0);
			}
		}

		public double[] GetY(int xIndex)
		{
			return new double[]{y[xIndex]};
		}

		private void ChartPrepareStyleHandler(object sender, ChartPrepareStyleInfoEventArgs e)
		{
			e.Style.Label = this.x[e.Index];
			e.Handled = true;
		}

		public bool GetEmpty(int index)
		{
			return false;			
		}

		public event ListChangedEventHandler Changed;
	}
}
